Bug 1899117 - nordugrid-arc fails to build with Python 3.10: SystemError: PY_SSIZE_T_CLEAN macro must be defined for '#' formats
Summary: nordugrid-arc fails to build with Python 3.10: SystemError: PY_SSIZE_T_CLEAN ...
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: nordugrid-arc
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Mattias Ellert
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: PYTHON3.10
TreeView+ depends on / blocked
 
Reported: 2020-11-18 14:57 UTC by Tomáš Hrnčiar
Modified: 2020-12-04 22:02 UTC (History)
4 users (show)

Fixed In Version: nordugrid-arc-6.9.0-1.fc34
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-12-04 22:02:28 UTC
Type: Bug


Attachments (Terms of Use)

Description Tomáš Hrnčiar 2020-11-18 14:57:08 UTC
nordugrid-arc fails to build with Python 3.10.0a2.

SystemError: PY_SSIZE_T_CLEAN macro must be defined for '#' formats

The above exception was the direct cause of the following exception:

Traceback (most recent call last):
  File "/builddir/build/BUILD/nordugrid-arc-6.8.1/src/services/a-rex/lrms/slurmpy/test/submit/memory-test_test_memory_cluster_and_queue_nodememory_1/../submit-SLURMPY-job", line 22, in <module>
    sys.exit(pySubmit.main("slurm", sys.argv[3], sys.argv[2]))
  File "/builddir/build/BUILD/nordugrid-arc-6.8.1/python/python/arc/lrms/pySubmit.py", line 38, in main
    error('Unexpected exception:\n%s' % traceback.format_exc(), 'pySubmit')
  File "/builddir/build/BUILD/nordugrid-arc-6.8.1/python/python/arc/lrms/common/log.py", line 53, in error
    _log(arc.ERROR, message, caller)
  File "/builddir/build/BUILD/nordugrid-arc-6.8.1/python/python/arc/lrms/common/log.py", line 67, in _log
    arc.Logger(arc.Logger_getRootLogger(), caller).msg(level, message)
  File "/builddir/build/BUILD/nordugrid-arc-6.8.1/python/python/arc/common.py", line 1300, in msg
    return _common.Logger_msg(self, *args)
SystemError: <built-in function Logger_msg> returned a result with an error set

https://docs.python.org/3.10/whatsnew/3.10.html#id2

The PY_SSIZE_T_CLEAN macro must now be defined to use PyArg_ParseTuple() and Py_BuildValue() formats which use #: es#, et#, s#, u#, y#, z#, U# and Z#. See Parsing arguments and building values and the PEP 353.
https://docs.python.org/3.10/c-api/arg.html#arg-parsing
https://www.python.org/dev/peps/pep-0353
https://bugs.python.org/issue40943

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.10/fedora-rawhide-x86_64/01770948-nordugrid-arc/

For all our attempts to build nordugrid-arc with Python 3.10, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/nordugrid-arc/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.10:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/

Let us know here if you have any questions.

Python 3.10 will be included in Fedora 35. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.10.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.


Note You need to log in before you can comment on or make changes to this bug.